"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.highlightNode = void 0;
var highlightNodeContent_1 = require("../highlightNodeContent");
var unescapeText_1 = require("../unescapeText");
/**
 * Highlight `words` in `subject`.
 */
var highlightNode = function (subject, words) {
    if (words === void 0) { words = []; }
    if (words.length === 0) {
        if (subject instanceof HTMLElement) {
            return subject.outerHTML;
        }
        return subject;
    }
    var el;
    if (subject instanceof HTMLElement) {
        el = subject;
    }
    else {
        // Create a DOM element here so we can detect and properly highlight HTML
        // inside the `subject` argument.
        el = document.createElement('div');
        el.innerHTML = subject;
    }
    // Highlight the content in the new node.
    var highlighted = highlightNodeContent_1.highlightNodeContent(el, words);
    if (typeof subject === 'string') {
        return unescapeText_1.unescapeText(highlighted.innerHTML);
    }
    return highlighted.outerHTML;
};
exports.highlightNode = highlightNode;
// eslint-disable-next-line import/no-default-export
exports.default = exports.highlightNode;
